#!/usr/bin/python

class Elgamal:

   def __init__(self, priv):
      # 1024 bit prime (generated with "openssl dhparam -text 1024")
      self.prime = 0x00eaaf764ab5ee2b69e1ff0a2e0767920c5ed5247aa15f34796487afe728256456b5a020080a683c5d5012f1a47929247690e616ef85c138bcb5798bfa13e83f96493de791c3ec31ff70763acd118cfb70ddf99827c19b022267de71e3410899bd62fc83d0a5c1ea275d6434b68aad8bb2cc0c17d7b116b6e9c2858007adb2e9c3
      # generator (generated by openssl)
      self.generator = 2

      self.privkey = priv

      self.pubkey = self.sam(self.generator, self.privkey, self.prime)

      self.sessionkey = 0


   #SQUARE-AND-MULTIPLY
   def sam(self, basis, exponent, mod):

      #convert integer to a binary string
      binary_exponent = bin(exponent)

      #remove the first two chars of the string (example string 0b1001)
      binary_exponent = binary_exponent[2:]

      temp = basis

      for i in range(len(binary_exponent) -1):
         #SQUARE
         temp = (temp * temp) % mod

         if binary_exponent[i+1] == '1':
            #MULTIPLY
            temp = (temp * basis) % mod

      #RESULT
      return temp


   def encrypt(self, message):
      if self.sessionkey > 0:
         return (message * self.sessionkey) % self.prime
      else:
         #if session key is not set return 0
         return 0


   def decrypt(self, cipher):
      if self.sessionkey > 0:
         sessionkeyinv = self.invers(self.prime, self.sessionkey)
         return (cipher * sessionkeyinv) % self.prime
      else:
         #if session key is not set return 0
         return 0


   def generatesessionkey(self, pub):
      self.sessionkey = self.sam(pub, self.privkey, self.prime)


   def setnewprivkey(self, priv):
      self.privkey = priv
      self.pubkey = self.sam(self.generator, self.privkey, self.prime)


   #EEA
   def invers(self, r0, r1):
      if r0 < r1:
         temp = r0
         r0 = r1
         r1 = temp
      s0 = t1 = 1
      s1 = t0 = s2 = t2 = 0
      while 1:
         mod = r0 % r1
         q = r0 // r1
         if mod == 0:
            return t1
         r0 = r1
         r1 = mod
         s2 = s0 - (q * s1)
         t2 = t0 - (q * t1)
         s0 = s1
         s1 = s2
         t0 = t1
         t1 = t2


   def getpubkey(self):
      return self.pubkey                
